#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <GuiIPAddress.au3>
#include <StaticConstants.au3>
Opt("GUIOnEventMode", 1)

Global $IP = @IPAddress1
Global $port = 33891
Global $Dimensions[2][9] = [[7, 95, 182, 7, 95, 182, 7, 95, 182],[8, 8, 8, 99, 99, 99, 187, 187, 187]]
Global $Buttons[9] = [-1, -1, -1, -1, -1, -1, -1, -1, -1]
Global $AQuiEstLeTour = 0 ; Le serveur
Global $DejaAffiche = 1
Global $IPAddress1, $Input2, $Form1
Global $boucle = 1
Global $ConnectedSocket, $MainSocket

_Config()
_Startup()
_Start()

While 1
	Sleep(100)
WEnd

Func _Config()
	$Form1 = GUICreate("", 130, 86, 192, 124)
	GUISetOnEvent($GUI_EVENT_CLOSE, "Form1_1Close")
	$Label1 = GUICtrlCreateLabel("IP:", 8, 8, 17, 17)
	$Label2 = GUICtrlCreateLabel("Port:", 8, 32, 26, 17)
	$Input2 = GUICtrlCreateInput($port, 40, 32, 81, 21, BitOR($GUI_SS_DEFAULT_INPUT, $ES_CENTER, $ES_NUMBER))
	$IPAddress1 = _GUICtrlIpAddress_Create($Form1, 32, 8, 89, 17)
	_GUICtrlIpAddress_Set($IPAddress1, $IP)
	$Button1 = GUICtrlCreateButton("Dmarrer", 8, 56, 113, 25)
	GUICtrlSetOnEvent(-1, "_Config_bis")
	GUISetState(@SW_SHOW, $Form1)
	While $boucle = 1
		Sleep(100)
	WEnd
EndFunc   ;==>_Config

Func _Config_bis()
	$boucle = 0
	$IP = _GUICtrlIpAddress_Get($IPAddress1)
	$port = GUICtrlRead($Input2)
	GUISetState(@SW_HIDE, $Form1)
EndFunc   ;==>_Config_bis

Func _Startup()
	TCPStartup()
	$MainSocket = TCPListen($IP, $port)
	If $MainSocket = -1 Then Exit
EndFunc   ;==>_Startup

Func _Start()
	$Form1_1 = GUICreate("Morpion", 275, 278, 192, 124)
	GUISetOnEvent(-3, "Form1_1Close")
	For $i = 0 To 8
		$Buttons[$i] = GUICtrlCreateButton("-", $Dimensions[0][$i], $Dimensions[1][$i], 81, 81, 0x2000)
		GUICtrlSetOnEvent(-1, "ButtonClick")
	Next
	GUISetState(@SW_SHOW)

	$ConnectedSocket = -1

	Do
		$ConnectedSocket = TCPAccept($MainSocket)
		ToolTip("Attente du client...")
	Until $ConnectedSocket <> -1

	ToolTip("")

	$IPAccepte = SocketToIP($ConnectedSocket)
	WinSetTitle($Form1_1, "", "Morpion Serveur - " & $IPAccepte)
	AdlibRegister("_While", 100)
EndFunc   ;==>_Start

Func ButtonClick()
	If $AQuiEstLeTour = 0 Then
		Local $id = @GUI_CtrlId - 7
		GUICtrlSetData(@GUI_CtrlId, "O")
		GUICtrlSetState(@GUI_CtrlId, 128)
		TCPSend($ConnectedSocket, Chr(49 + $id))
		$AQuiEstLeTour = 1
	EndIf
EndFunc   ;==>ButtonClick

Func _While()
	_Check()
	$Received = TCPRecv($ConnectedSocket, 1024)
	If $Received <> "" Then
		If GUICtrlRead($Buttons[Number($Received) - 1]) <> "-" Then
			MsgBox(0, "serveur", "Impossible de se mettre l")
			TCPSend($ConnectedSocket, "againplease")
		Else
			GUICtrlSetData($Buttons[Number($Received) - 1], "X")
			GUICtrlSetState($Buttons[Number($Received) - 1], 128)
			$AQuiEstLeTour = 0
		EndIf
	EndIf
EndFunc   ;==>_While

Func _Check()
	;Horizontal
	For $i = 0 To 6 Step 3
		$value = GUICtrlRead($Buttons[$i]) & GUICtrlRead($Buttons[$i + 1]) & GUICtrlRead($Buttons[$i + 2])
		If StringRegExp($value, "X{3}|O{3}") Then
			If $DejaAffiche Then MsgBox(0, "", "Gagnant horizontal : " & StringLeft($value, 1))
			$DejaAffiche = 0
		EndIf
	Next
	;Vertical
	For $i = 0 To 2
		$value = GUICtrlRead($Buttons[$i]) & GUICtrlRead($Buttons[$i + 3]) & GUICtrlRead($Buttons[$i + 6])
		If StringRegExp($value, "X{3}|O{3}") Then
			If $DejaAffiche Then MsgBox(0, "", "Gagnant vertical : " & StringLeft($value, 1))
			$DejaAffiche = 0
		EndIf
	Next
	;Diagonale
	$value = GUICtrlRead($Buttons[0]) & GUICtrlRead($Buttons[4]) & GUICtrlRead($Buttons[8])
	If StringRegExp($value, "X{3}|O{3}") Then
		If $DejaAffiche Then MsgBox(0, "", "Gagnant diagonale : " & StringLeft($value, 1))
		$DejaAffiche = 0
	EndIf
	$value = GUICtrlRead($Buttons[2]) & GUICtrlRead($Buttons[4]) & GUICtrlRead($Buttons[6])
	If StringRegExp($value, "X{3}|O{3}") Then
		If $DejaAffiche Then MsgBox(0, "", "Gagnant diagonale : " & StringLeft($value, 1))
		$DejaAffiche = 0
	EndIf
EndFunc   ;==>_Check

Func Form1_1Close()
	TCPCloseSocket($ConnectedSocket)
	TCPShutdown()
	Exit
EndFunc   ;==>Form1_1Close

Func SocketToIP($SHOCKET)
	Local $sockaddr, $aRet
	$sockaddr = DllStructCreate("short;ushort;uint;char[8]")
	$aRet = DllCall("Ws2_32.dll", "int", "getpeername", "int", $SHOCKET, _
			"ptr", DllStructGetPtr($sockaddr), "int*", DllStructGetSize($sockaddr))
	If Not @error And $aRet[0] = 0 Then
		$aRet = DllCall("Ws2_32.dll", "str", "inet_ntoa", "int", DllStructGetData($sockaddr, 3))
		If Not @error Then $aRet = $aRet[0]
	Else
		$aRet = 0
	EndIf
	$sockaddr = 0
	Return $aRet
EndFunc   ;==>SocketToIP